<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\export;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\export\ExportLists;
use app\adminapi\logic\export\ExportLogic;
use app\adminapi\validate\export\ExportValidate;
use app\common\service\ExcelExportService;


/**
 * Export控制器
 * Class ExportController
 * @package app\adminapi\controller
 */
class ExportController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/18 13:31
     */
    public function lists()
    {
        return $this->dataLists(new ExportLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/18 13:31
     */
    public function add()
    {
        $params = (new ExportValidate())->post()->goCheck('add');
        $result = ExportLogic::add($params);
        if (true === $result) {
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(ExportLogic::getError());
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/18 13:31
     */
    public function edit()
    {
        $params = (new ExportValidate())->post()->goCheck('edit');
        $result = ExportLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(ExportLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/18 13:31
     */
    public function delete()
    {
        $params = (new ExportValidate())->post()->goCheck('delete');
        ExportLogic::delete($params);
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/11/18 13:31
     */
    public function detail()
    {
        $params = (new ExportValidate())->goCheck('detail');
        $result = ExportLogic::detail($params);
        return $this->data($result);
    }


    /*
     * @notes 通用下载
     */
    public function generalDownload()
    {
        $params = $this->request->get();
        if(empty($params['download_type'])) return $this->fail('参数错误');
        $result = ExportLogic::add([
            'download_type' => $params['download_type']??0,
            'params' => $params,
            'name' => $params['download_name']??'',
            'admin_id' => $this->adminId,
        ]);
        if (false === $result) {
            return $this->fail(ExportLogic::getError());
        }
        // 暂时 - 立即生成导出文件
        (new ExcelExportService)->download($result);
        return $this->success('添加成功-'.$result, [], 1, 1);
    }


}